/* AUDIO.CPP - Programmed by Maarten Hofman */
/* 150404: Started programming */

#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/soundcard.h>
#include <malloc.h>

#include "soundbyte.h" 

#define DEVICE_NAME "/dev/dsp"

int frag_size;
unsigned char *silence;

int check_free_fragments(int audio_fd) {
audio_buf_info info;

  if(ioctl(audio_fd,SNDCTL_DSP_GETOSPACE,&info)==-1) return 0;
  return info.fragments;
}

void close_audio_device(int audiofd) {
  close(audiofd);
  free(silence);
}

int open_audio_device() {
int audio_fd,format,stereo,speed,i;

  format=AFMT_U8;
  stereo=0;
  speed=11025;
  audio_fd=open(DEVICE_NAME,O_WRONLY,0);
  if(audio_fd==-1) {
    perror(DEVICE_NAME);
    exit(1);
  }
  if(ioctl(audio_fd,SNDCTL_DSP_SETFMT,&format)==-1) {
    perror("SNDCTL_DSP_SETFMT");
    exit(2);
  } 
  if(ioctl(audio_fd,SNDCTL_DSP_STEREO,&stereo)==-1) {
    perror("SNDCTL_DSP_STEREO");
    exit(3);
  }
  if(ioctl(audio_fd,SNDCTL_DSP_SPEED,&speed)==-1) {
    perror("SNDCTL_DSP_SPEED");
    exit(4);
  }
  if(ioctl(audio_fd,SNDCTL_DSP_GETBLKSIZE,&frag_size)==-1) {
    perror("SNDCTL_DSP_GETBLKSIZE");
    exit(5);
  }
  printf("Fragment size: %d\n",frag_size);
  silence=(unsigned char *)malloc(frag_size);
  for(i=0;i<frag_size;i++) silence[i]=0x80;
  return audio_fd;
}
