/* FONT.H - Programmed by Jonathan Hobson */
/* 220404: Maarten Hofman: Added Bar() functionality */
/* 300404: Maarten Hofman: Changed Bar into hitpoint_bar */
/* 010504: Maarten Hofman: Moved bar stuff to twod */

#ifndef __FONT_H__
#define __FONT_H__

#include "dma.h"
#include <stdio.h>
#include <stdarg.h>

class CFont
{
public:
	CFont();
	~CFont();

	bool Load(const char * strWidths);

	void Render(const int x, const int y, const char * strText, 
				uint8 R = 0x80, uint8 G = 0x80, uint8 B = 0x80, uint8 A = 0x80,int partial=0,int iTrans=1);
	void RenderR(const int x, const int y, const char * strText, 
				uint8 R = 0x80, uint8 G = 0x80, uint8 B = 0x80, uint8 A = 0x80);
	void printf(const int x, const int y, uint8 R, uint8 G, uint8 B, uint8 A, const char * strText, ...);
	void printfR(const int x, const int y, uint8 R, uint8 G, uint8 B, uint8 A, const char * strText, ...);

	int GetStringWidth(const char * strText);
protected:
	unsigned char * m_FontWidths;
};

inline void CFont::RenderR(const int x, const int y, const char *strText,
						   uint8 R = 0x80, uint8 G = 0x80, uint8 B = 0x80, uint8 A = 0x80)
{
	Render(x - GetStringWidth(strText), y, strText, R, G, B, A);
}

#endif
